#include "FramebufferDevice.h"

FramebufferDevice::FramebufferDevice()
{
	fd = open("/dev/fb0", O_RDWR);
	if (!fd)
	{
		std::cout << "[Graphics] failed to open /dev/fb0" << std::endl;
		return;
	}
	
	ioctl(fd, FBIOGET_VSCREENINFO, &info);
	
	//std::cout << "[Graphics] opened framebuffer" << std::endl;
	//std::cout << "[Graphics] 	XRes: " << info.xres << " YRes: " << info.yres << " BPP: " << info.bits_per_pixel << std::endl;
	
	fb = static_cast<unsigned char*>(mmap(0, info.xres * info.yres * 3, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0));
}

int FramebufferDevice::getHeight()
{
	return info.yres;
}

int FramebufferDevice::getWidth()
{
	return info.xres;
}

void FramebufferDevice::setEmpty()
{
	memset(fb, 0, info.xres * info.yres * 3);
}

void FramebufferDevice::setPixel(unsigned int X, unsigned int Y, unsigned char red, unsigned char green, unsigned char blue)
{
	if (X > info.xres || Y > info.yres) return;
	unsigned int p = (Y * info.xres + X) * 3;
	fb[p] = blue;
	fb[p + 1] = green;
	fb[p + 2] = red;
}


